diff --git a/sysdeps/i386/fpu/e_pow.S b/sysdeps/i386/fpu/e_pow.S
index 1ea6f09c15..a3280bf144 100644
--- a/sysdeps/i386/fpu/e_pow.S
+++ b/sysdeps/i386/fpu/e_pow.S
@@ -79,7 +79,7 @@ ENTRY(__ieee754_pow)
 	cmpb	$0x40, %ah	// is y == 0 ?
 	je	11f
 
-	cmpb	$0x05, %ah	// is y == ±inf ?
+	cmpb	$0x05, %ah	// is y == Â±inf ?
 	je	12f
 
 	cmpb	$0x01, %ah	// is y == NaN ?
@@ -95,10 +95,10 @@ ENTRY(__ieee754_pow)
 	movb	%ah, %dh
 	andb	$0x45, %ah
 	cmpb	$0x40, %ah
-	je	20f		// x is ±0
+	je	20f		// x is Â±0
 
 	cmpb	$0x05, %ah
-	je	15f		// x is ±inf
+	je	15f		// x is Â±inf
 
 	cmpb	$0x01, %ah
 	je	32f		// x is NaN
@@ -173,7 +173,7 @@ ENTRY(__ieee754_pow)
 	DBL_NARROW_EVAL_UFLOW_NONNAN
 	ret
 
-	/* y is ±NAN */
+	/* y is Â±NAN */
 30:	fldl	4(%esp)		// x : y
 	fldl	MO(one)		// 1.0 : x : y
 	fucomp	%st(1)		// x : y
@@ -267,13 +267,13 @@ ENTRY(__ieee754_pow)
 	ret
 
 
-	// pow(x,±0) = 1
+	// pow(x,Â±0) = 1
 	.align ALIGNARG(4)
 11:	fstp	%st(0)		// pop y
 	fldl	MO(one)
 	ret
 
-	// y == ±inf
+	// y == Â±inf
 	.align ALIGNARG(4)
 12:	fstp	%st(0)		// pop y
 	fldl	MO(one)		// 1
@@ -304,7 +304,7 @@ ENTRY(__ieee754_pow)
 
 	cfi_adjust_cfa_offset (8)
 	.align ALIGNARG(4)
-	// x is ±inf
+	// x is Â±inf
 15:	fstp	%st(0)		// y
 	testb	$2, %dh
 	jz	16f		// jump if x == +inf
@@ -362,12 +362,12 @@ ENTRY(__ieee754_pow)
 
 	cfi_adjust_cfa_offset (8)
 	.align ALIGNARG(4)
-	// x is ±0
+	// x is Â±0
 20:	fstp	%st(0)		// y
 	testb	$2, %dl
 	jz	21f		// y > 0
 
-	// x is ±0 and y is < 0.  We must find out whether y is an odd integer.
+	// x is Â±0 and y is < 0.  We must find out whether y is an odd integer.
 	testb	$2, %dh
 	jz	25f
 
@@ -414,7 +414,7 @@ ENTRY(__ieee754_pow)
 
 	cfi_adjust_cfa_offset (8)
 	.align ALIGNARG(4)
-	// x is ±0 and y is > 0.  We must find out whether y is an odd integer.
+	// x is Â±0 and y is > 0.  We must find out whether y is an odd integer.
 21:	testb	$2, %dh
 	jz	22f
 
diff --git a/sysdeps/i386/fpu/e_powl.S b/sysdeps/i386/fpu/e_powl.S
index 2826ba4980..50692c7381 100644
--- a/sysdeps/i386/fpu/e_powl.S
+++ b/sysdeps/i386/fpu/e_powl.S
@@ -85,7 +85,7 @@ ENTRY(__ieee754_powl)
 	cmpb	$0x40, %ah	// is y == 0 ?
 	je	11f
 
-	cmpb	$0x05, %ah	// is y == ±inf ?
+	cmpb	$0x05, %ah	// is y == Â±inf ?
 	je	12f
 
 	cmpb	$0x01, %ah	// is y == NaN ?
@@ -101,10 +101,10 @@ ENTRY(__ieee754_powl)
 	movb	%ah, %dh
 	andb	$0x45, %ah
 	cmpb	$0x40, %ah
-	je	20f		// x is ±0
+	je	20f		// x is Â±0
 
 	cmpb	$0x05, %ah
-	je	15f		// x is ±inf
+	je	15f		// x is Â±inf
 
 	cmpb	$0x01, %ah
 	je	32f		// x is NaN
@@ -195,7 +195,7 @@ ENTRY(__ieee754_powl)
 	LDBL_CHECK_FORCE_UFLOW_NONNAN
 	ret
 
-	/* y is ±NAN */
+	/* y is Â±NAN */
 30:	fldt	4(%esp)		// x : y
 	fldl	MO(one)		// 1.0 : x : y
 	fucomp	%st(1)		// x : y
@@ -247,7 +247,7 @@ ENTRY(__ieee754_powl)
 	cfi_adjust_cfa_offset (-36)
 	ret
 
-	// pow(x,±0) = 1, unless x is sNaN
+	// pow(x,Â±0) = 1, unless x is sNaN
 	.align ALIGNARG(4)
 11:	fstp	%st(0)		// pop y
 	fldt	4(%esp)		// x
@@ -265,7 +265,7 @@ ENTRY(__ieee754_powl)
 	fadd	%st(0)
 	ret
 
-	// y == ±inf
+	// y == Â±inf
 	.align ALIGNARG(4)
 12:	fstp	%st(0)		// pop y
 	fldl	MO(one)		// 1
@@ -297,7 +297,7 @@ ENTRY(__ieee754_powl)
 
 	cfi_adjust_cfa_offset (8)
 	.align ALIGNARG(4)
-	// x is ±inf
+	// x is Â±inf
 15:	fstp	%st(0)		// y
 	testb	$2, %dh
 	jz	16f		// jump if x == +inf
@@ -358,12 +358,12 @@ ENTRY(__ieee754_powl)
 
 	cfi_adjust_cfa_offset (8)
 	.align ALIGNARG(4)
-	// x is ±0
+	// x is Â±0
 20:	fstp	%st(0)		// y
 	testb	$2, %dl
 	jz	21f		// y > 0
 
-	// x is ±0 and y is < 0.  We must find out whether y is an odd integer.
+	// x is Â±0 and y is < 0.  We must find out whether y is an odd integer.
 	testb	$2, %dh
 	jz	25f
 
@@ -413,7 +413,7 @@ ENTRY(__ieee754_powl)
 
 	cfi_adjust_cfa_offset (8)
 	.align ALIGNARG(4)
-	// x is ±0 and y is > 0.  We must find out whether y is an odd integer.
+	// x is Â±0 and y is > 0.  We must find out whether y is an odd integer.
 21:	testb	$2, %dh
 	jz	22f
 
diff --git a/sysdeps/ia64/fpu/s_tanf.S b/sysdeps/ia64/fpu/s_tanf.S
index 8bbdee9232..30d11a6f88 100644
--- a/sysdeps/ia64/fpu/s_tanf.S
+++ b/sysdeps/ia64/fpu/s_tanf.S
@@ -224,7 +224,7 @@ LOCAL_OBJECT_END(coeff_B)
 LOCAL_LIBM_ENTRY(cotf)
 
 { .mlx
-      getf.exp  rExp        = f8                    // ***** Get 2ˆ17 * s + E
+      getf.exp  rExp        = f8                    // ***** Get 2^17 * s + E
       movl      rSigRcpPiby2= 0xA2F9836E4E44152A    // significand of 2/Pi
 }
 { .mlx
@@ -251,7 +251,7 @@ LOCAL_LIBM_END(cotf)
 GLOBAL_IEEE754_ENTRY(tanf)
 
 { .mlx
-      getf.exp  rExp        = f8                    // ***** Get 2ˆ17 * s + E
+      getf.exp  rExp        = f8                    // ***** Get 2^17 * s + E
       movl      rSigRcpPiby2= 0xA2F9836E4E44152A    // significand of 2/Pi
 }
 { .mlx
diff --git a/sysdeps/x86_64/fpu/e_powl.S b/sysdeps/x86_64/fpu/e_powl.S
index 2a404eb3f8..2b0d48350f 100644
--- a/sysdeps/x86_64/fpu/e_powl.S
+++ b/sysdeps/x86_64/fpu/e_powl.S
@@ -80,7 +80,7 @@ ENTRY(__ieee754_powl)
 	cmpb	$0x40, %ah	// is y == 0 ?
 	je	11f
 
-	cmpb	$0x05, %ah	// is y == ±inf ?
+	cmpb	$0x05, %ah	// is y == Â±inf ?
 	je	12f
 
 	cmpb	$0x01, %ah	// is y == NaN ?
@@ -93,10 +93,10 @@ ENTRY(__ieee754_powl)
 	movb	%ah, %dh
 	andb	$0x45, %ah
 	cmpb	$0x40, %ah
-	je	20f		// x is ±0
+	je	20f		// x is Â±0
 
 	cmpb	$0x05, %ah
-	je	15f		// x is ±inf
+	je	15f		// x is Â±inf
 
 	cmpb	$0x01, %ah
 	je	31f		// x is NaN
@@ -180,7 +180,7 @@ ENTRY(__ieee754_powl)
 	LDBL_CHECK_FORCE_UFLOW_NONNAN
 	ret
 
-	/* y is ±NAN */
+	/* y is Â±NAN */
 30:	fldt	8(%rsp)		// x : y
 	fldl	MO(one)		// 1.0 : x : y
 	fucomip	%st(1),%st	// x : y
@@ -223,7 +223,7 @@ ENTRY(__ieee754_powl)
 	cfi_adjust_cfa_offset (-40)
 	ret
 
-	// pow(x,±0) = 1, unless x is sNaN
+	// pow(x,Â±0) = 1, unless x is sNaN
 	.align ALIGNARG(4)
 11:	fstp	%st(0)		// pop y
 	fldt	8(%rsp)		// x
@@ -241,7 +241,7 @@ ENTRY(__ieee754_powl)
 	fadd	%st(0)
 	ret
 
-	// y == ±inf
+	// y == Â±inf
 	.align ALIGNARG(4)
 12:	fstp	%st(0)		// pop y
 	fldl	MO(one)		// 1
@@ -277,7 +277,7 @@ ENTRY(__ieee754_powl)
 	ret
 
 	.align ALIGNARG(4)
-	// x is ±inf
+	// x is Â±inf
 15:	fstp	%st(0)		// y
 	testb	$2, %dh
 	jz	16f		// jump if x == +inf
@@ -343,12 +343,12 @@ ENTRY(__ieee754_powl)
 	ret
 
 	.align ALIGNARG(4)
-	// x is ±0
+	// x is Â±0
 20:	fstp	%st(0)		// y
 	testb	$2, %dl
 	jz	21f		// y > 0
 
-	// x is ±0 and y is < 0.  We must find out whether y is an odd integer.
+	// x is Â±0 and y is < 0.  We must find out whether y is an odd integer.
 	testb	$2, %dh
 	jz	25f
 
@@ -392,7 +392,7 @@ ENTRY(__ieee754_powl)
 	ret
 
 	.align ALIGNARG(4)
-	// x is ±0 and y is > 0.  We must find out whether y is an odd integer.
+	// x is Â±0 and y is > 0.  We must find out whether y is an odd integer.
 21:	testb	$2, %dh
 	jz	22f
 